<?php

if ($STEP == 0) {
	
	// Gather some diagnostics first, then confirm transfer
	$recordCount = 0;
	$sec_id = false;
	$db = connectSourceDB();
	$dbSink = connectSinkDB();
	
	if ($db) {
		$recordCount = dbGetRowCount($settings['fusion_db'].".".$settings['fusion_prefix'].'_articles', $db);
		if (! $recordCount) {
			$err = true;
			$err_msgs[] = "Unable to retrieve record count for articles table";
		}
		
		$q = "SELECT id FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_sections WHERE title = 'Imported Articles'";
		logQuery($q);
		$sec_id = dbGetOneValue($q, $dbSink);
		
	}
	
	echo '
	<p>
		There are '.$recordCount.' articles for transfer. <br />
	';
	if ($CLEAR == 1) {
		echo 'You have chosen to clear the existing records and import them afresh.';
	} else {
		echo 'You have chosen to update to synchronize any recent changes.';
	}
	echo '
	</p>
	<p>
	';
	if ($sec_id && isNumeric($sec_id)) {
		echo 'The "Imported Articles" section has already been created ('.$sec_id.')';
	} else {
		echo 'The "Imported Articles" section will need to be created';
	}
	echo '
	</p>
	<p>
		Proceed? [<a href="index.php?act=convert_articles&step=1&clear='.$CLEAR.'">Yes</a>] [<a href="index.php">No</a>]
	</p>
	';
} else if ($STEP == 1) {
	
	$dbSource = connectSourceDB();
	$dbSink = connectSinkDB();
	logQuery('Databases connected');
	
	$art_count = 0;
	$cat_count = 0;
	
	if ($dbSource && $dbSink) {
		$q = "SELECT id FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_sections WHERE title = 'Imported Articles'";
		logQuery($q);
		$sec_id = dbGetOneValue($q, $dbSink);
		
		if (! $sec_id) {
			$q = 
			"INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_sections (
				title, name, alias, image, scope, image_position, description, published,
				checked_out, checked_out_time, ordering, access, count, params
			) VALUES (
				'Imported Articles', '', 'imported-articles', '', 'content', 'left', '',
				0, 0, 0, 0, 0, 0, ''
			)";
			
			logQuery($q);
			
			$sec_id = dbInsert($q, $dbSink);
			
			if (! $sec_id) {
				
				addError("Unable to create section for imported articles");
				
			}
		}
		
		if (! $err) {
			
			$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_categories WHERE section = ".$sec_id;
			logQuery($q);
			$r = dbQuery($q, $dbSink);
			
			if ($CLEAR == 1) {
				$q = "DELETE FROM ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content WHERE sectionid = ".$sec_id;
				logQuery($q);
				$r = dbQuery($q, $dbSink);
			}
			
			$q = "SELECT * FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_article_cats";
			logQuery($q);
			$cat_rs = dbQuery($q, $dbSource);
			
			$cat_map = array();
			
			while ($rw = dbGetRowHash($cat_rs)) {
				$alias = makeAlias($rw['article_cat_name']);
				
				$qi = "INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_categories (
					parent_id, title, name, alias, image, section, image_position, description, published,
					checked_out, checked_out_time, ordering, access, count, params
				) VALUES (
					0, '".$rw['article_cat_name']."', '', '".$alias."', '', ".$sec_id.", 'left', '',
					0, 0, 0, 0, 0, 0, ''
				)";
				
				logQuery($qi);
				
				$c_id = dbInsert($qi, $dbSink);
				
				$cat_map[$rw['article_cat_id']] = $c_id;
				$cat_count++;
			}
			
			$q = "SELECT * FROM ".$settings['fusion_db'].".".$settings['fusion_prefix']."_articles";
			logQuery($q);
			$art_rs = dbQuery($q, $dbSource);
			
			$attribs="show_title=
link_titles=
show_intro=
show_section=
link_section=
show_category=
link_category=
show_vote=
show_author=
show_create_date=
show_modify_date=
show_pdf_icon=
show_print_icon=
show_email_icon=
language=
keyref=
art_file=";
			
			while ($rw = dbGetRowHash($art_rs)) {
				$alias = makeAlias($rw['article_subject']);
				
				$thisCat = $cat_map[$rw['article_cat']];
				if (! isNumeric($thisCat)) {
					$thisCat = 0;
				}
				
				$m_attribs = $attribs;
				
				if (strlen(trim($rw['article_filename'])) > 0) {
					$m_attribs .= trim($rw['article_filename']);
				}
				
				$qi = "
				INSERT INTO ".$settings['joomla_db'].".".$settings['joomla_prefix']."_content (
					`title`, `alias`, `title_alias`, `introtext`, `fulltext`,
					`state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`,
					`modified`, `modified_by`, `checked_out`, `checked_out_time`, 
					`publish_up`, `publish_down`, `images`, `urls`, `attribs`,
					`version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`,
					`hits`, `metadata`
				) VALUES (
					'".prepTextForDB($rw['article_subject'])."', '".$alias."', '', '".prepTextForDB($rw['article_snippet'])."', 
					'".prepTextForDB($rw['article_article'])."', 1, ".$sec_id.", 0, ".$thisCat.", 
					'".sqlDate($rw['article_datestamp'])."', '".prepTextForDB($rw['article_name'])."', '',
					0, '', 0, '', '".sqlDate($rw['article_datestamp'])."', '', '', '', '".$m_attribs."', 1,
					0, 0, '', '', 0, ".$rw['article_reads'].", ''
				);";
				
				logQuery($qi);
				
				$r = dbInsert($qi, $dbSink);
				$art_count++;
			}
		}
	} else {
		addError("Unable to connect to databases");
	}
	echo '
	<div class="menu">
		[<a href="index.php">Home</a>]
	</div>
	';
	
	displayErrors();
	
	echo '
	<p>
		'.$cat_count.' categories and '.$art_count.' articles were transferred.
	</p>
	';
	
	
}
