<?php
/*

NECTAR

Version:	1.0
Author:	Geoff Capper 2009

*/
// Prevent direct access to this script. VIA_HOME is defined only in the top
// level index.php.
if (!defined("VIA_HOME")) { header("Location: ../index.php"); exit; }

function loadSettings() {
	
	$f = file('settings.dat');
	
	$settings = array();
	
	if ($f) {
		foreach ($f as $line) {
			if (strlen(trim($line)) > 0) {
				$bits = explode('=', $line);
				$settings[trim($bits[0])] = trim($bits[1]);
			}
		}
	}
	return $settings;
}


function connectSourceDB() {
    global $settings;
	
	$sourceDB = mysql_connect("localhost", $settings['fusion_dbuser'], $settings['fusion_dbpass'], true);
	if ($sourceDB) {
		$r = mysql_select_db($settings['fusion_db'], $sourceDB);
		if (! $r) {
			addError("Unable to connect to select database: ".mysql_errno()." - ".mysql_error());
		}
	} else {
		addError("Unable to connect to database server: ".mysql_errno()." - ".mysql_error());
	}
	return $sourceDB;
}

function connectSinkDB() {
    global $settings;
	
	$sinkDB = mysql_connect("localhost", $settings['joomla_dbuser'], $settings['joomla_dbpass'], true);
	if ($sinkDB) {
		$r = mysql_select_db($settings['joomla_db'], $sinkDB);
		if (! $r) {
			addError("Unable to connect to select database: ".mysql_errno()." - ".mysql_error());
		}
	} else {
		addError("Unable to connect to database server: ".mysql_errno()." - ".mysql_error());
	}
	return $sinkDB;
}

// Database functions
function dbQuery($query, $dbref) {
	global $err_msgs;
	global $err;
	
	$result_set = @mysql_query($query, $dbref);
	
	if (!$result_set) {
		$err = true;
		$err_msgs[] = "Unable to run database query: ".mysql_errno($dbref)." - ".mysql_error($dbref);
	}
	
	return $result_set;
}

// Database functions
function dbInsert($query, $dbref) {
	global $err_msgs;
	global $err;
	
	$id = false;
	
	$result_set = @mysql_query($query, $dbref);
	
	if (!$result_set) {
		//echo "Unable to run database query: ".mysql_errno()." - ".mysql_error();
		$err = true;
		//echo "Unable to run database query: ".mysql_errno()." - ".mysql_error();
		$err_msgs[] = "Unable to run database query: ".mysql_errno($dbref)." - ".mysql_error($dbref) . " - " . $query;
		//return false;
		$id = false;
		
	} else {
		$id = mysql_insert_id($dbref);
	}
	return $id;
}

function dbRecordCount($result_set) {
	
	global $err_msgs;
	global $err;
	
	$count = mysql_num_rows($result_set);
	
	if (mysql_errno() > 0) {
		$err = true;
		$err_msgs[] = "Unable to return a count of rows provided: ".mysql_errno()." - ".mysql_error();
	} else if ($count == 0) {
		$count = @mysql_affected_rows($result_set);
		if (mysql_errno() > 0) {
			$err = true;
			$err_msgs[] = "Unable to return a count of rows provided: ".mysql_errno()." - ".mysql_error();
		}
	}
	return $count;
	
}

function dbGetRowHash($result_set) {
	global $err_msgs;
	global $err;
	if (! $result_set) {
		$err = true;
		$err_msgs[] = "Result set passed to dbGetRowHash was invalid.";
	} else {
		$row = mysql_fetch_assoc($result_set);
		
		if ($row !== false && mysql_errno() > 0) {
			$err = true;
			$err_msgs[] = "Unable to obtain row as associative array: ".mysql_errno()." - ".mysql_error();
			
		} else {
			return $row;
		}
	}
	return false;
}

function dbGetRowCount($tableName, $dbref, $where="") {
	
	global $settings, $err, $err_msgs;
	
	$q = "SELECT COUNT(*) FROM ".$tableName." ".$where;
	return dbGetOneValue($q, $dbref);
}

function dbGetOneValue($q, $dbref) {
	global $settings, $err, $err_msgs;
	
	$rs = dbQuery($q, $dbref);
	if ($rs) {
		$row = @mysql_fetch_row($rs);
		if ($row !== false && mysql_errno() > 0) {
			$err = true;
			$err_msgs[] = "Unable to obtain row as associative array: ".mysql_errno()." - ".mysql_error();
		} else {
			return $row[0];
		}
	}
	return false;
}

function dbGetRowArray($result_set) {
	global $err_msgs;
	global $err;
	
	if (! $result_set) {
		$err = true;
		$err_msgs[] = "Result set passed to dbGetRowHash was invalid.";
	} else {
		$row = @mysql_fetch_row($result_set);
		if ($row !== false && mysql_errno() > 0) {
			$err = true;
			$err_msgs[] = "Unable to obtain row as associative array: ".mysql_errno()." - ".mysql_error();
		} else {
			return $row;
		}
	}
}

function makeAlias($name) {
	$nm = str_ireplace(" ", "-", $name);
	$nm = str_ireplace("'", "", $nm);
	$nm = str_ireplace('"', "", $nm);
	$nm = strtolower($nm);
	return $nm;
}


function addDebug($msg) {
	global $debug;
	$debug[] = $msg;
}

function displayErrors() {
	global $err, $err_msgs;
	
	if ($err_msgs) {
		echo '
		<h2>Errors Were Encountered!</h2>
		<ul>
		';
		foreach ($err_msgs as $e) {
			echo '<li>'.$e.'</li>
			';
		}
		echo '</ul>
		';
	}
}


// All errors are added to the debug list as well...
function addError($msg, $fatal=false) {
	global $err, $err_msgs, $fatal_err;
	$err = true;
	$err_msgs[] = $msg;
	if (! $fatal_err && $fatal) {
		$fatal_err = $fatal;
	}
	addDebug($msg);
}

function addAllErrors($msgs, $fatal=false) {
	global $err, $err_msgs, $fatal_err;
	$err = true;
	if (is_array($msgs)) {
		$err_msgs = array_merge($err_msgs, $msgs);
	} else {
		$err_msgs[] = $msg;
	}
	if (! $fatal_err && $fatal) {
		$fatal_err = $fatal;
	}
}

function auditLog($user, $msg) {
	logQuery($msg);
}

function logQuery($qry) {
	global $err, $err_msgs;
	/*
	$fn = "queryLog.txt";
	$fh = fopen($fn, 'a') or die("can't open query log file");
	fwrite($fh, $qry);
	fclose($fh);
	*/
	//$err_msgs[] = $qry;
}

/* Returns the value, or an unquoted null if the particular value is empty
 * This should only be applied to fields that can be null in the database.
 * USE:  mysql_real_escape_string() 
 */
function nullSafeQuote($value) {
	$rval = "";
	if ($value == null || $value == "") {
		$rval = "NULL";
	} else {
		$rval = "'".$value."'";
	}
	return $rval;
}
// For non-nullable values.
function safeQuote($value) {
	return "'".$value."'";
}

function safeNum($value) {
	return (isValidId($value) ? $value : 0);
}
function nullSafeNum($value) {
	addDebug('nullSafeNum has value: '.$value.' and will return: ' . (isNumeric($value) ? $value : "NULL"));
	return (isNumeric($value) ? $value : "NULL");
}


function safeDateNull($value) {
	$rv = "";
	if ($value == null || $value == "") {
		$rv = "NULL";
	} else {
		$rv = safeDate($value);
	}
	return $rv;
}

function safeDate($value) {
	$rv = "";
	list($d, $m, $y) = explode("/", $value);
	if (checkdate($m, $d, $y)) {
		$rv = $y . "-" . $m . "-" . $d;
	} else {
		$rv = date("Y-m-d", time());
	}
	return "'".$rv."'";
}

function currencyFormat($value) {
	return number_format($value, 2, ".", "");
}

function prepTextForDB($txt) {
	// Escape single quotes that aren't already escaped...
	$txt = stripslashes($txt);
	$txt = addslashes($txt);
	return $txt;
}

function sqlDate($tm) {
	return date("Y-m-d H:i:s", $tm);
}

function getTimeFromSQLDate($sqldate) {
	$t = false;
	if ($sqldate != null && strlen($sqldate) > 0) {
		list($dt,$tm) = explode(" ", $sqldate);
		list($yr,$mn,$dy) = explode("-", $dt);
		//list($hr,$nn,$sc) = explode(":", $tm);
		$hr = 0;
		$nn = 0;
		$sc = 0;
		if (checkdate($mn, $dy, $yr)) {
			$t = mktime( $hr, $nn, $sc, $mn, $dy, $yr);
		}
	}
	return $t;
}

function formatSQLDate($sqldate) {
	$rv = "";
	addDebug('formatSQLDate: '.$sqldate);
	if ($sqldate != null && strlen($sqldate) > 0) {
		list($dt,$tm) = explode(" ", $sqldate);
		list($yr,$mn,$dy) = explode("-", $dt);
		//list($hr,$nn,$sc) = explode(":", $tm);
		$hr = 0;
		$nn = 0;
		$sc = 0;
		if (checkdate($mn, $dy, $yr)) {
			$rv = date("d/m/Y", mktime( $hr, $nn, $sc, $mn, $dy, $yr));
		}
	}
	return $rv;
}

//date("d/m/Y H:i", mktime( $hr, $nn, $sc, $dy, $mn, $yr));


function formatText($str) {
	return nl2br(prepDisplay($str));
}

function prepDisplay($str) {
	return htmlspecialchars($str);
}

// Strip Input Function, prevents HTML in unwanted places
function stripHTML($text) {
	if (ini_get('magic_quotes_gpc')) $text = stripslashes($text);
	$search = array("\"", "'", "\\", '\"', "\'", "<", ">", "&nbsp;");
	$replace = array("&quot;", "&#39;", "&#92;", "&quot;", "&#39;", "&lt;", "&gt;", " ");
	$text = str_replace($search, $replace, $text);
	return $text;
}

function cleanFormInput($form_key, $html_fields=array()) {
	
	global $sys_settings;
	
	$safe_values = array();
	
	foreach ($form_key as $fld) {
		if (! is_array($_POST[$fld])) {
			$v = trim($_POST[$fld]);
			$safe_values[$fld] = stripHTML(censorText($v));
		} else {
			$new_ary = array();
			foreach ($_POST[$fld] as $elem) {
				$v = trim($elem);
				$v = stripHTML(censorText($v));
				$new_ary[] = $v;
			}
			$safe_values[$fld] = $new_ary;
		}
	}
	
	return $safe_values;
	
}

function isNumeric($value) {
	return (preg_match("/^[0-9]+$/", $value));
}

function isValidId($value) {
	return (isNumeric($value) && $value != 0);
}

// Returns a filename with all lowercase and no spaces.
function cleanName($fname) {
	$fname = strtolower($fname);
	$fname = str_ireplace(" ", "", $fname);
	return $fname;
}

function getUniqueFilename($img_name, $img_ext, $folder) {
	$idx = 1;
	$new_name = cleanName($img_name . '_' . $idx . $img_ext);
	while (file_exists($folder . $new_name)) {
		$idx = $idx + 1;
		$new_name = cleanName($img_name . '_' . $idx . $img_ext);
	}
	return $new_name;
}

